From: Maximiliano Sandoval R <msandova@gnome.org>
Date: Tue, 3 Jan 2023 20:58:03 +0100
Subject: file-chooser: Set writable flag correctly

Previously this was evaluating as if (gvariant != NULL) which is always
true if the option is present, this caused all files to be passed down
as read-write regardless of what the impl, app and user requested.

Origin: upstream, 1.16.1, commit:26e3ff258b8f744d7f459598edd91465ab756cd0
---
 src/file-chooser.c | 4 +++-
 1 file changed, 3 insertions(+), 1 deletion(-)

diff --git a/src/file-chooser.c b/src/file-chooser.c
index e314140..f7a33a5 100644
--- a/src/file-chooser.c
+++ b/src/file-chooser.c
@@ -79,6 +79,7 @@ send_response_in_thread_func (GTask        *task,
   const char **uris;
   GVariant *choices;
   GVariant *current_filter;
+  GVariant *writable;
 
   g_variant_builder_init (&results, G_VARIANT_TYPE_VARDICT);
   g_variant_builder_init (&ruris, G_VARIANT_TYPE_STRING_ARRAY);
@@ -95,7 +96,8 @@ send_response_in_thread_func (GTask        *task,
   if (response != 0)
     goto out;
 
-  if (!g_variant_lookup_value (options, "writable", G_VARIANT_TYPE("b")))
+  writable = g_variant_lookup_value (options, "writable", G_VARIANT_TYPE("b"));
+  if (writable && !g_variant_get_boolean (writable))
     flags &= ~DOCUMENT_FLAG_WRITABLE;
 
   choices = g_variant_lookup_value (options, "choices", G_VARIANT_TYPE ("a(ss)"));
